/*
 *	gridftp.c
 *
 *	Main function for gridftp_client, calls subroutines.
 *
 *  Created on: June 2009
 *	Author: Christian Loeschen
 */

#include <stdio.h>
#include <stdlib.h>
#include "gridftp.h"

int main(int argc, char **argv) {

	if (argc == 4) {

		if (strcmp(argv[1], "cp") == 0) {

			return gridftp_cp(argv[2], argv[3]);
		}

		else if (strcmp(argv[1], "mv") == 0) {

			return gridftp_mv(argv[2], argv[3]);
		}

		else if (strcmp(argv[1], "get") == 0) {

			return gridftp_get(argv[2], argv[3]);
		}

		else if (strcmp(argv[1], "put") == 0) {

			return gridftp_put(argv[2], argv[3]);
		}

		else if (strcmp(argv[1], "chmod") == 0) {

			return gridftp_chmod(argv[2], argv[3]);
		}
	}
	else if (argc == 3) {

		if (strcmp(argv[1], "del") == 0) {

			return gridftp_del(argv[2]);
		}

		if (strcmp(argv[1], "ls") == 0) {

			return gridftp_ls(argv[2]);
		}

		else if (strcmp(argv[1], "mkdir") == 0) {

			return gridftp_mkdir(argv[2]);
		}

		else if (strcmp(argv[1], "rmdir") == 0) {

			return gridftp_rmdir(argv[2]);
		}

		else if (strcmp(argv[1], "exist") == 0) {

			return gridftp_exist(argv[2]);
		}

		else if (strcmp(argv[1], "size") == 0) {

			return gridftp_size(argv[2]);
		}

		else if (strcmp(argv[1], "cksm") == 0) {

			return gridftp_cksm(argv[2]);
		}

		else if (strcmp(argv[1], "modtime") == 0) {

			return gridftp_modtime(argv[2]);
		}

		else if (strcmp(argv[1], "feat") == 0) {

			return gridftp_feat(argv[2]);
		}
	}

	printf(
			"usage: gridftp\n"
			"\tget|put|cp|mv <src-url> <dst-url>\n"
			"\tls|del|rmdir|mkdir|exist|size|cksm|modtime|feat <url>\n"
			"\tchmod <mode> <url>\n"
			);

	exit(0);
}
