#include "globus_ftp_client.h"
#include "gridftp.h"

#ifdef GRIDFTP_IRODS_MODULE
#include "rsApiHandler.h"
#include "apiHeaderAll.h"
#include "dataObjUnlink.h"
#include "gridftpMS.h"

int msiGridftpFuncTest(msParam_t *src, msParam_t *dst, msParam_t *result, ruleExecInfo_t *rei) {

	int i, error = 0;
	char* res = (char*) malloc(1024 * sizeof(char));
	msParam_t *outParam = (msParam_t*) malloc(sizeof(outParam));
	bzero(&outParam, sizeof(outParam));

	//	create test directory and file names
	char* rodsFile2 = (char*) malloc(1024 * sizeof(char));
	char* dstDir = (char*) malloc(1024 * sizeof(char));
	char* dstFile1 = (char*) malloc(1024 * sizeof(char));
	char* dstFile2 = (char*) malloc(1024 * sizeof(char));

	sprintf(rodsFile2, "%s_2", (char *) src->inOutStruct);

	char timeStr[40];
	time_t rawtime;
	struct tm* timeinfo;
	time(&rawtime);
	timeinfo = localtime(&rawtime);
	strftime(timeStr, 40, "%Y-%m-%d_%H-%M-%S", timeinfo);
	char *tm = (char*) malloc(10 * sizeof(char));

	for (i = 8; i >= 0; i--) {
		tm[i] = (char) (rand() % ('z' - '0' + 1) + '0');
		if (tm[i] > '9' && tm[i] < 'A' || tm[i] > 'Z' && tm[i] < 'a')
			i++;
	}
	tm[9] = '\0';
	sprintf(dstDir, "%s/irods_test_%s_%s", (char*) dst->inOutStruct, timeStr, tm);
	sprintf(dstFile1, "%s%s", dstDir, "/test.one");
	sprintf(dstFile2, "%s%s", dstDir, "/test.two");

	fillStrInMsParam(dst, dstDir);
	error = msiGridftpMkdir(dst, rei);

	if (error != 1) {
		strncpy(res, "\ngridftp mkdir: FAILED", strlen("\ngridftp mkdir: FAILED "));
	}
	else {
		strncpy(res, "\ngridftp mkdir: ok", strlen("\ngridftp mkdir: ok"));

		fillStrInMsParam(dst, dstFile1);
		error = msiGridftpPut(src, dst, rei);

		if (error != 1) {
			strncat(res, "\ngridftp put: FAILED", strlen("\ngridftp put: FAILED"));
		}
		else {
			strncat(res, "\ngridftp put: ok", strlen("\ngridftp put: ok"));

			fillStrInMsParam(src, dstFile1);
			fillStrInMsParam(dst, dstFile2);
			error = msiGridftpCp(src, dst, rei);

			if (error != 1) {
				strncat(res, "\ngridftp cp: FAILED", strlen("\ngridftp cp: FAILED"));
			}
			else {
				strncat(res, "\ngridftp cp: ok", strlen("\ngridftp cp: ok"));

				fillStrInMsParam(dst, dstDir);
				error = msiGridftpLs(dst, outParam, rei);

				if (error != 1) {
					strncat(res, "\ngridftp ls: FAILED", strlen("\ngridftp ls: FAILED"));
				}
				else {
					strncat(res, "\ngridftp ls: ok", strlen("\ngridftp ls: ok"));
				}

				fillStrInMsParam(dst, dstFile2);
				error = msiGridftpExist(dst, outParam, rei);

				if (error != 1) {
					strncat(res, "\ngridftp exist: FAILED", strlen("\ngridftp exist: FAILED"));
				}
				else {
					strncat(res, "\ngridftp exist: ok", strlen("\ngridftp exist: ok"));
				}

				error = msiGridftpSize(dst, outParam, rei);

				if (error != 1) {
					strncat(res, "\ngridftp size: FAILED", strlen("\ngridftp size: FAILED"));
				}
				else {
					strncat(res, "\ngridftp size: ok", strlen("\ngridftp size: ok"));
				}

				error = msiGridftpModtime(dst, outParam, rei);

				if (error != 1) {
					strncat(res, "\ngridftp modtime: FAILED", strlen("\ngridftp modtime: FAILED"));
				}
				else {
					strncat(res, "\ngridftp modtime: ok", strlen("\ngridftp modtime: ok"));
				}

				error = msiGridftpCksm(dst, outParam, rei);

				if (error != 1) {
					strncat(res, "\ngridftp cksm: FAILED", strlen("\ngridftp cksm: FAILED"));
				}
				else {
					strncat(res, "\ngridftp cksm: ok", strlen("\ngridftp cksm: ok"));
				}

				fillStrInMsParam(src, "600");	// mode parameter
				error = msiGridftpChmod(src, dst, rei);

				if (error != 1) {
					strncat(res, "\ngridftp chmod: FAILED", strlen("\ngridftp chmod: FAILED"));
				}
				else {
					strncat(res, "\ngridftp chmod: ok", strlen("\ngridftp chmod: ok"));
				}

				fillStrInMsParam(src, dstFile2);
				fillStrInMsParam(dst, rodsFile2);
				error = msiGridftpGet(src, dst, rei);

				if (error != 1) {
					strncat(res, "\ngridftp get: FAILED", strlen("\ngridftp get: FAILED"));
				}
				else {
					strncat(res, "\ngridftp get: ok", strlen("\ngridftp get: ok"));
				}

				fillStrInMsParam(dst, dstFile2);
				error = msiGridftpDel(dst, rei);

				if (error != 1) {
					strncat(res, "\ngridftp del: FAILED", strlen("\ngridftp del: FAILED"));
				}
			}

			fillStrInMsParam(src, dstFile1);
			fillStrInMsParam(dst, dstFile2);
			error = msiGridftpMv(src, dst, rei);

			if (error != 1) {
				strncat(res, "\ngridftp mv: FAILED", strlen("\ngridftp mv: FAILED"));
				fillStrInMsParam(dst, dstFile1);
			}
			else {
				strncat(res, "\ngridftp mv: ok", strlen("\ngridftp mv: ok"));
				fillStrInMsParam(dst, dstFile2);
			}

			error = msiGridftpDel(dst, rei);

			if (error != 1) {
				strncat(res, "\ngridftp del: FAILED", strlen("\ngridftp del: FAILED"));
			}
			else {
				strncat(res, "\ngridftp del: ok", strlen("\ngridftp del: ok"));
			}
		}
		fillStrInMsParam(dst, dstDir);
		error = msiGridftpRmdir(dst, rei);

		if (error != 1) {
			strncat(res, "\ngridftp rmdir: FAILED", strlen("\ngridftp rmdir: FAILED"));
		}
		else {
			strncat(res, "\ngridftp rmdir: ok", strlen("\ngridftp rmdir: ok"));
		}
	}

	dataObjInp_t *dataObjUnlinkInp = (dataObjInp_t *) malloc(sizeof(dataObjInp_t));
	memset(dataObjUnlinkInp, 0, sizeof (dataObjInp_t));
	rstrcpy(dataObjUnlinkInp->objPath, rodsFile2, MAX_NAME_LEN);
	rsDataObjUnlink(rei->rsComm, dataObjUnlinkInp);

	free(dataObjUnlinkInp);
	free(outParam);

	fillStrInMsParam(result, res);
	return 1;
}

#endif
